#include <windows.h>
#include "common.h"
#include "spi.h"
#include "pikture.h"
#include "main.h"

struct tagPiktureVal{
	HBITMAP hbm;
	BOOL fit;

	LPTSTR fname;

	int x;
	int y;

	POINT premp;
};

LRESULT CALLBACK PiktureWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		SetWindowLong(hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) | WS_EX_CLIENTEDGE);
		{
			struct tagPiktureVal* pv;

			pv = halloc(sizeof(struct tagPiktureVal));

			pv->hbm = NULL;
			pv->fname = NULL;
			pv->fit = TRUE;

			SetWindowLong(hWnd, 0, (LONG)pv);
		}
		break;
	case WM_DESTROY:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			if(pv->hbm)
			{
				DeleteObject(pv->hbm);
				hfree(pv->fname);

				pv->hbm = NULL;
				pv->fname = NULL;
			}

			hfree(pv);
		}
		break;

	case WM_PAINT:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			{
				PAINTSTRUCT ps;
				HDC hdc;
				RECT wrc;

				GetClientRect(hWnd, &wrc);

				hdc = BeginPaint(hWnd, &ps);

				//Rectangle(hdc, 1, 1, wrc.right - 1, wrc.bottom - 1);
				//Rectangle(hdc, 3, 3, wrc.right, wrc.bottom);

				{
					HBRUSH b = GetSysColorBrush(COLOR_3DFACE);

					FillRect(hdc, &wrc, b);

					DeleteObject(b);
				}

				if(pv->hbm)
				{
					HDC hbkdc;
					HBITMAP holdbmp;
					BITMAPINFO bi = {0};

					hbkdc = CreateCompatibleDC(hdc);
					holdbmp = SelectObject(hbkdc, pv->hbm);

					bi.bmiHeader.biSize = sizeof(bi.bmiHeader);

					if(!GetDIBits(hbkdc, pv->hbm, 0, 1, NULL, &bi, 0))
						// 񂾂
						_asm int 3;//FillRect(hdc, &wrc, GetStockObject(BLACK_BRUSH));
					else
					{
						// \邺
						if(pv->fit)
						{
							SetStretchBltMode(hdc, Option.PreviewStretchMode);
							if(Option.KeepAspectRatio)
							{
								SIZE ws, ps;

								ws.cx = wrc.right;
								ws.cy = wrc.bottom;

								ps.cx = bi.bmiHeader.biWidth;
								ps.cy = bi.bmiHeader.biHeight;

								if(ws.cx && ws.cy)	// DivideByZero΍
								{
									if(ws.cx * 100 / ws.cy <= ps.cx * 100 / ps.cy)	// 
										StretchBlt(hdc, 0, (ws.cy - (ps.cy * ws.cx / ps.cx)) / 2, ws.cx, ps.cy * ws.cx / ps.cx, hbkdc, 0, 0, ps.cx, ps.cy, SRCCOPY);
									else	// c
										StretchBlt(hdc, (ws.cx - (ps.cx * ws.cy / ps.cy)) / 2, 0, ps.cx * ws.cy / ps.cy, ws.cy, hbkdc, 0, 0, ps.cx, ps.cy, SRCCOPY);
								}
							}else
							{
								StretchBlt(hdc, 0, 0, wrc.right, wrc.bottom, hbkdc, 0, 0, bi.bmiHeader.biWidth, bi.bmiHeader.biHeight, SRCCOPY);
							}
						}else
						{
							BitBlt(hdc, 0, 0, wrc.right, wrc.bottom, hbkdc, pv->x, pv->y, SRCCOPY);
						}
					}

					//BitBlt(hdc, 0, 0, wrc.right, wrc.bottom, hbkdc, 0, 0, SRCCOPY);

					SelectObject(hbkdc, holdbmp);
					DeleteDC(hbkdc);
				}

				if(GetFocus() == hWnd)
				{
					DrawFocusRect(hdc, &wrc);
				}

				EndPaint(hWnd, &ps);
			}
		}

		break;
	case WM_SIZE:
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	case WM_USER:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			if(pv->hbm)
			{
				DeleteObject(pv->hbm);
				hfree(pv->fname);

				pv->hbm = NULL;
				pv->fname = NULL;
			}

			// do load
			if(lParam)
			{
				HBITMAP hbm;

				if(hbm = spiGetPicture((LPCTSTR)lParam))
				{
					pv->hbm = hbm;
					pv->fit = TRUE;

					pv->fname = lstrdup((LPCTSTR)lParam);
				}
			}
		}

		InvalidateRect(hWnd, NULL, FALSE);

		break;
	case WM_RBUTTONDOWN:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			pv->fit = !pv->fit;

			if(!pv->fit)
			{
				BITMAPINFO bi = {0};
				RECT wrc;
				POINT pict;
				HDC hdc;

				GetClientRect(hWnd, &wrc);

				bi.bmiHeader.biSize = sizeof(bi.bmiHeader);

				hdc = GetDC(hWnd);

				if(!GetDIBits(hdc, pv->hbm, 0, 1, NULL, &bi, 0))
				{
					// _(OoO)^
					pv->x = 0;
					pv->y = 0;
				}else
				{
					SIZE ws, ps;

					ws.cx = wrc.right;
					ws.cy = wrc.bottom;

					ps.cx = bi.bmiHeader.biWidth;
					ps.cy = bi.bmiHeader.biHeight;

					if(ws.cx && ws.cy)	// DivideByZero΍
					{
						// ̏
						if(ws.cx * 100 / ws.cy <= ps.cx * 100 / ps.cy)
						{
							pict.x = 0, pict.y = (ws.cy - (ps.cy * ws.cx / ps.cx)) / 2;

							pv->x = ((short)LOWORD(lParam) - pict.x) * ps.cx / ws.cx - (short)LOWORD(lParam);
							pv->y = ((short)HIWORD(lParam) - pict.y) * ps.cx / ws.cx - (short)HIWORD(lParam);
						}else
						{
							pict.x = (ws.cx - (ps.cx * ws.cy / ps.cy)) / 2, pict.y = 0;

							pv->x = ((short)LOWORD(lParam) - pict.x) * ps.cy / ws.cy - (short)LOWORD(lParam);
							pv->y = ((short)HIWORD(lParam) - pict.y) * ps.cy / ws.cy - (short)HIWORD(lParam);
						}
					}
				}

				ReleaseDC(hWnd, hdc);

				// 
			}

			SetFocus(hWnd);

			InvalidateRect(hWnd, NULL, FALSE);
		}
		break;
	case WM_SETFOCUS:
	case WM_KILLFOCUS:
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case WM_LBUTTONDOWN:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			if(!pv->fit)
			{
				GetCursorPos(&pv->premp);

				SetCapture(hWnd);
			}

			SetFocus(hWnd);
		}
		break;
	case WM_MOUSEMOVE:
		if(GetCapture() == hWnd)
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);
			POINT mp;

			GetCursorPos(&mp);

			pv->x += pv->premp.x - mp.x;
			pv->y += pv->premp.y - mp.y;

			pv->premp = mp;

			SetCursor(LoadCursor(NULL, IDC_SIZEALL));

			InvalidateRect(hWnd, NULL, FALSE);
		}

		break;
	case WM_LBUTTONUP:
		ReleaseCapture();
		break;
	case WM_MBUTTONDOWN:
		SetFocus(hWnd);
		break;
	case WM_LBUTTONDBLCLK:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			if(pv->fname)
				ShellExecute(hWnd, NULL, pv->fname, NULL, NULL, SW_SHOWNORMAL);
		}
		break;

	case WM_KEYDOWN:
	case WM_KEYUP:
		{
			struct tagPiktureVal* pv = (struct tagPiktureVal*)GetWindowLong(hWnd, 0);

			switch((int)wParam)
			{
			case VK_UP:
			case VK_DOWN:
			case VK_LEFT:
			case VK_RIGHT:
				if(msg == WM_KEYDOWN)
				{
					int amount = 1;

					if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
						amount = 10;
					if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
						amount = 50;

					switch((int)wParam)
					{
					case VK_UP:		pv->y -= amount;	break;
					case VK_DOWN:	pv->y += amount;	break;
					case VK_LEFT:	pv->x -= amount;	break;
					case VK_RIGHT:	pv->x += amount;	break;
					}
				}

				InvalidateRect(hWnd, NULL, FALSE);

				break;
			case VK_SPACE:
				if(msg == WM_KEYDOWN)
				{
					RECT rc;

					GetClientRect(hWnd, &rc);

					SendMessage(hWnd, WM_RBUTTONDOWN, 0, MAKELPARAM(rc.right / 2, rc.bottom / 2));
				}
				break;

			default:
				// Ɋۓ
				return SendMessage(GetParent(hWnd), msg, wParam, lParam);
			}
		}

		/*
	case WM_SETCURSOR:
		if(GetCapture() != hWnd)
			SetCursor(LoadCursor(NULL, IDC_ARROW));
		else
			SetCursor(LoadCursor(NULL, IDC_SIZEALL));
		break;
		*/
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL piktureInit(void)
{
	WNDCLASSEX wc = {0};

	wc.cbSize = sizeof(wc);
	wc.cbWndExtra = sizeof(void*);
	wc.hInstance = GetModuleHandle(NULL);
	wc.lpfnWndProc = PiktureWndProc;
	wc.lpszClassName = WC_PIKTURE;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;

	return RegisterClassEx(&wc);
}

void piktureTerminate(void)
{
	return;
}
